#include <stdio.h>
#include <math.h>
#include "defs.h"

/*
This is a test program to compare the performance of C_FFT.c with
four1.c.  It is provided for information.  You have my permisson to 
link it with your own copy of four1.c for your own use.  Note
that the licence of four1.c is not compatible with the GPL.  

The program is primarly useful as a guide to the useage differences 
between C-FFT.c and four1.c. 

Karen Bryden 
Manager, Voice Systems and Technologies 


E-mail: karen.bryden@crc.ca



Copyright (C) 2000 Her Majesty the Queen in Right of Canada
                   Communications Research Centre Canada
                   An agency of Industry Canada.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

See File COPYING.txt

*/


//#define transformSize 512
#define transformSize 8

void main(int argc, char *argv[])
{
float four1Data[2 * transformSize];
struct cpxFloat C_FFTdata[transformSize];
int iii;
double pi = 3.14159265358979323;

//prepare data for four1 and C_FFT
for(iii = 0; iii < transformSize; iii++)
	{
four1Data[2 * iii] = (float)sin(2.0 * pi / transformSize * iii);
four1Data[2 * iii + 1] = 0.0;
C_FFTdata[iii].re = (float)sin(2.0 * pi / transformSize * iii);
C_FFTdata[iii].im = 0.0;
	}
//four1(four1Data - 1, transformSize, 1);
four1(four1Data - 1, transformSize, -1);

//C_FFT(C_FFTdata, transformSize, 1);
C_FFT(C_FFTdata, transformSize, -1);

//print the result
for(iii = 0; iii < transformSize; iii++)
	{
printf("%12.6f ", four1Data[2 * iii]);
printf("%12.6f ", C_FFTdata[iii].re);
printf("%12.6f ", four1Data[2 * iii + 1]);
printf("%12.6f ", C_FFTdata[iii].im);
printf("\n");
	}
}
